#ifndef _CLI_VALUE_PARAM_H_
#define _CLI_VALUE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/Registry.h>

namespace cli {

class ValueParam final : public Param {
	std::unique_ptr < cli::Arg > m_arg;

public:
	ValueParam ( std::unique_ptr < cli::Arg > arg ) : Param ( true ), m_arg ( std::move ( arg ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return abstraction::Registry::getImmediateAbstraction ( ext::to_string < std::string > ( ), m_arg->eval ( environment ) );
	}
};

} /* namespace cli */

#endif /* _CLI_VALUE_PARAM_H_ */
