#ifndef _CLI_VARIABLE_PARAM_H_
#define _CLI_VARIABLE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/Registry.h>

namespace cli {

class VariableParam final : public Param {
	std::unique_ptr < cli::Arg > m_name;

public:
	VariableParam ( std::unique_ptr < cli::Arg > name, bool move ) : Param ( move ), m_name ( std::move ( name ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return environment.getVariable ( m_name->eval ( environment ) );
	}
};

} /* namespace cli */

#endif /* _CLI_VARIABLE_PARAM_H_ */
